# -*- mode: ruby -*-
# vi: set ft=ruby :

Vagrant.configure("2") do |config|
	config.vm.box = "ubuntu/focal64"
	config.vm.hostname = "game01"
	config.vm.network "private_network", ip: "192.168.56.3"
	config.vm.provision "shell", inline: <<-SHELL
		
		echo "----------------------------------------------------------------"
		echo "UPDATE, UPGRADE, INSTALL"
		sudo apt-get update
		#sudo apt-get dist-upgrade -y
		sudo apt-get install git -y
		sudo apt-get install nginx -y
		sudo apt-get install curl -y
		sudo apt-get install apt-transport-https -y
		sudo apt-get install lsb-release -y
		echo "UPDATE, UPGRADE, INSTALL FINISH"
		echo "----------------------------------------------------------------"
		echo "install node js"
		curl -sL https://deb.nodesource.com/setup_16.x -o nodesource_setup.sh
		sudo bash nodesource_setup.sh
		sudo apt install nodejs
		node -v
		rm /home/vagrant/nodesource_setup.sh
		echo "Node js install complete"
		echo "----------------------------------------------------------------"
		echo "clone repo game"
		cd /home/vagrant/
                git clone https://gitfront.io/r/deusops/JnacRhR4iD8q/2048-game.git
		echo "clone repo complete"
		echo "----------------------------------------------------------------"
		echo "Create nginx file for application"
		sudo touch /etc/nginx/sites-available/game2048
		sudo tee /etc/nginx/sites-available/game2048 <<EOF
server {
	listen 80;
	server_name game01.test;
	index index.js
	root /home/vagrant/2048-game/;
	access_log /var/log/nginx/game_access.log;
	error_log /var/log/nginx/game_error.log;

location / {
  	try_files $uri $uri/ /index.js$args;
  	}

location ~ \.js$ {
  	proxy_pass http://127.0.0.1:8080;
  	}
} 
EOF
		sudo ln -s /etc/nginx/sites-available/game2048 /etc/nginx/sites-enabled 
		sudo nginx -t
		sudo systemctl restart nginx.service
		echo "file created complete"                
		echo "----------------------------------------------------------------"		
		echo "build application"
		cd /home/vagrant/2048-game/
		npm install --include=dev
		npm run build
		npm audit fix
		echo "build application complete"
		echo "----------------------------------------------------------------"
		echo "create system init apllication"
		sudo tee /etc/systemd/system/game2048.service <<EOF
[Unit]
Description=2048 game nodejs application
After=network.target

[Service]
Type=simple
User=root
WorkingDirectory=/home/vagrant/2048-game/
ExecStart=/usr/bin/npm start
Restart=always
StandardOutput=syslog
StandardError=syslog
SyslogIdentifier=game2048

[Install]
WantedBy=multi-user.target
EOF
		echo "system unit complete"
		echo "----------------------------------------------------------------"

		echo "restart services"
		sudo systemctl daemon-reload
		sudo systemctl enable game2048.service
		sudo systemctl start game2048.service
		echo "finish"
		
	SHELL
end

